//----------------------------------------------------------------------------
//  Project SetMsIr
//  Okada Corp.
//  Copyright (c) 1997. All Rights Reserved.
//
//  TuVXe: SetMsIr Application
//  t@C:     stmsirad.cpp
//  쐬:       Hiromu Okada
//
//  Tv
//  ~~~~
//  TSetMsIrAboutDlg (TDialog) ̃Cve[Vp̃\[Xt@C
//
//----------------------------------------------------------------------------

#include <owl/pch.h>
#include <stdio.h>
#if defined(BI_PLAT_WIN16)
# include <ver.h>
#endif

#include "stmsirap.h"
#include "stmsirad.h"


TProjectRCVersion::TProjectRCVersion(TModule* module)
{
  uint32  fvHandle;
  uint    vSize;
  char    appFName[255];
  TAPointer<char> subBlockName = new char[255];

  FVData = 0;

  module->GetModuleFileName(appFName, sizeof appFName);
  OemToAnsi(appFName, appFName);
  uint32 dwSize = ::GetFileVersionInfoSize(appFName, &fvHandle);
  if (dwSize) {
    FVData  = (void far *)new char[(uint)dwSize];
    if (::GetFileVersionInfo(appFName, fvHandle, dwSize, FVData)) {
      // obt@ɃRs[鎖ɂCWin16  -dc RpCXCb`(萔R[h
      // ZOgɓƂ)w肵ꍇłCVerQueryValue ܂삷悤ɂB
      // ́CMicrosoft  ver.dll  subBlockName Ŏ镶ɏ݂Ă܂Ƃ
      // ɑΏ邽߂̂̂ł
      //
      strcpy(subBlockName, "\\VarFileInfo\\Translation");
      if (!::VerQueryValue(FVData, subBlockName,(void far* far*)&TransBlock, &vSize)) {
        delete[] FVData;
        FVData = 0;
      }
      else
        // ㉺[hXbvāCwsprintf  lang-charset 𐳂ŏo͂悤ɂ
        //
        *(uint32 *)TransBlock = MAKELONG(HIWORD(*(uint32 *)TransBlock), LOWORD(*(uint32 *)TransBlock));
    }
  }
}


TProjectRCVersion::~TProjectRCVersion()
{
  if (FVData)
    delete[] FVData;
}


bool TProjectRCVersion::GetProductName(LPSTR& prodName)
{
  uint    vSize;
  TAPointer<char> subBlockName = new char[255];

  if (FVData) {
    sprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(uint32 *)TransBlock,(LPSTR)"ProductName");
    return FVData ? ::VerQueryValue(FVData, subBlockName,(void far* far*)&prodName, &vSize) : false;
  } else
    return false;
}


bool TProjectRCVersion::GetProductVersion(LPSTR& prodVersion)
{
  uint    vSize;
  TAPointer<char> subBlockName = new char[255];

  if (FVData) {
    sprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(uint32 *)TransBlock,(LPSTR)"ProductVersion");
    return FVData ? ::VerQueryValue(FVData, subBlockName,(void far* far*)&prodVersion, &vSize) : false;
  } else
    return false;
}


bool TProjectRCVersion::GetCopyright(LPSTR& copyright)
{
  uint    vSize;
  TAPointer<char> subBlockName = new char[255];

  if (FVData) {
    sprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(uint32 *)TransBlock,(LPSTR)"LegalCopyright");
    return FVData ? ::VerQueryValue(FVData, subBlockName,(void far* far*)&copyright, &vSize) : false;
  } else
    return false;
}


bool TProjectRCVersion::GetDebug(LPSTR& debug)
{
  uint    vSize;
  TAPointer<char> subBlockName = new char[255];

  if (FVData) {
    sprintf(subBlockName, "\\StringFileInfo\\%08lx\\%s", *(uint32 *)TransBlock,(LPSTR)"SpecialBuild");
    return FVData ? ::VerQueryValue(FVData, subBlockName,(void far* far*)&debug, &vSize) : false;
  } else
    return false;
}


//{{TSetMsIrAboutDlg Implementation}}


//--------------------------------------------------------
// TSetMsIrAboutDlg
// ~~~~~~~~~~
// \z / j󎞂̏
//
TSetMsIrAboutDlg::TSetMsIrAboutDlg(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> RXgN^p̃R[h͂
}


TSetMsIrAboutDlg::~TSetMsIrAboutDlg()
{
  Destroy();

  // INSERT>> fXgN^p̃R[h͂
}


void TSetMsIrAboutDlg::SetupWindow()
{
  LPSTR prodName = 0, prodVersion = 0, copyright = 0, debug = 0;

  // VERSIONINFO ɊÂlCX^eBbNRg[̃eLXg擾
  //
  TStatic* versionCtrl = new TStatic(this, IDC_VERSION, 255);
  TStatic* copyrightCtrl = new TStatic(this, IDC_COPYRIGHT, 255);
  TStatic* debugCtrl = new TStatic(this, IDC_DEBUG, 255);

  TDialog::SetupWindow();

  // VERSIONINFO ̏
  //
  TProjectRCVersion applVersion(GetModule());

  // iEĩo[W擾
  //
  if (applVersion.GetProductName(prodName) && applVersion.GetProductVersion(prodVersion)) {
    // IDC_VERSION ͐iƃo[WԍłCIDC_VERSION ̏l
    // Version ƂP(ǂ̌ɂĂ)CiCVERSIONCio[Wł
    //
    char buffer[255];
    char versionName[128];

    buffer[0] = '\0';
    versionName[0] = '\0';

    versionCtrl->GetText(versionName, sizeof versionName);
    sprintf(buffer, "%s %s %s", prodName, versionName, prodVersion);

    versionCtrl->SetText(buffer);
  }

  // @IȃRs[Cg擾
  //
  if (applVersion.GetCopyright(copyright))
    copyrightCtrl->SetText(copyright);

  //  VERSIONINFO \[X݂ȂCSpecialBuild eLXg擾
  //
  if (applVersion.GetDebug(debug))
    debugCtrl->SetText(debug);
}
